#include <TrainingSet.h>
#include <ComplexLayerNetwork.h>
#include <MultiLayerNetwork.h>
#include <Exception.h>

#include <vector>
#include <iostream>


using namespace std;
using namespace annie;


vector<real> real_pair(real a, real b) {
  vector<real> rval;
  rval.push_back(a);
  rval.push_back(b);
  return rval;
}



vector<real> real_single(real a) {
  vector<real> rval;
  rval.push_back(a);
  return rval;
}

int main() {

  try {
  ComplexLayerNetwork  test(2);
  test.addLayer(1);
  test.addLayer(1);
 
  test.connectLayer(0);
  test.connectLayer(1);

  test.connect(0,0,2,0);
  test.connect(0,1,2,0);

  TrainingSet ts(2,1);


  real input1[]={0,0}; real output1[]={0};
  real input2[]={1,0}; real output2[]={1};
  real input3[]={0,1}; real output3[]={1};
  real input4[]={1,1}; real output4[]={0};
  
	

  TrainingSet T(2,1);

  //Add the various sample data to the training set
  T.addIOpair(input1,output1);
  T.addIOpair(input2,output2);
  T.addIOpair(input3,output3);
  T.addIOpair(input4,output4);
  
  
  cout<<"Results before training:"<<endl;
  cout<<"0 XOR 0 = "<<test.getOutput (input1).back() << endl;
  cout<<"1 XOR 0 = "<<test.getOutput (input2).back() << endl;
  cout<<"0 XOR 1 = "<<test.getOutput (input3).back() << endl;
  cout<<"1 XOR 1 = "<<test.getOutput (input4).back() << endl;
  
  cout<<"Training the network...please be patient if the no. of epochs is large"<<endl;

  //Train the network using the training set provided
  test.train(T,10000,0.8);

  cout<<"Results after training 10000 epochs"<<endl;
  cout<<"0 XOR 0 = "<<test.getOutput (input1).back() << endl;
  cout<<"1 XOR 0 = "<<test.getOutput (input2).back() << endl;
  cout<<"0 XOR 1 = "<<test.getOutput (input3).back() << endl;
  cout<<"1 XOR 1 = "<<test.getOutput (input4).back() << endl;

  test.save("ComplexLayerXOR.sav");
  ComplexLayerNetwork t2("ComplexLayerXOR.sav");  

  cout<<"Results after saving to file and then loading " << endl;
  cout<<"0 XOR 0 = "<<t2.getOutput (input1).back() << endl;
  cout<<"1 XOR 0 = "<<t2.getOutput (input2).back() << endl;
  cout<<"0 XOR 1 = "<<t2.getOutput (input3).back() << endl;
  cout<<"1 XOR 1 = "<<t2.getOutput (input4).back() << endl;


  }
 
  catch (Exception &e) {
     cout << e.what() << endl;
  }

  return 0;
}
